﻿<template>
    <section class="form-mood-container">
        <form class="form-mood" novalidate @submit.prevent="handleSubmitSearch">
            <div class="mood-panel"
                 @mousemove="drag"
                 @mousedown="startDrag"
                 ref="container">
                <p :id="t('moods.label.happy')" :class="{'closest': closestMood.id==0}">{{ t('moods.title.happy') }}</p> 
                <p :id="t('moods.label.focused')" :class="{'closest': closestMood.id==1}">{{ t('moods.title.focused') }}</p> 
                <p :id="t('moods.label.chill')" :class="{'closest': closestMood.id==2}">{{ t('moods.title.chill') }}</p> 
                <p :id="t('moods.label.tired')" :class="{'closest': closestMood.id==3}">{{ t('moods.title.tired') }}</p> 
                <p :id="t('moods.label.sad')" :class="{'closest': closestMood.id==4}">{{ t('moods.title.sad') }}</p> 
                <p :id="t('moods.label.angry')" :class="{'closest': closestMood.id==5}">{{ t('moods.title.angry') }}</p> 
                <p :id="t('moods.label.scared')" :class="{'closest': closestMood.id==6}">{{ t('moods.title.scared') }}</p>
                <p :id="t('moods.label.exited')" :class="{'closest': closestMood.id==7}">{{ t('moods.title.exited') }}</p>
                <div class="pointer"
                     ref="pointer"></div>
            </div>
            <button type="submit" class="form__submit btn">{{ t('pages.home.findMovieButton') }}</button>
        </form>
    </section>

    <hr />

    <section class="random-movie-container">
        <h3>{{ t('pages.home.subtitle') }}</h3>
        <form :action="t('routes.home.randomMovie.fullPath')">
            <button type="submit" class="form__submit btn">{{ t('pages.home.randomMovieButton') }}</button>
        </form>
    </section>
</template>

<script lang="ts" setup>
    import { ref, onMounted } from "vue";
    import { useI18n } from "vue3-i18n";
    import { Mood, MOODS } from "@/types/entities/mood";

    const pointer = ref<any>();
    const container = ref<any>();
    let isDragging = false;
    let containerTop: number;
    let containerLeft: number;
    let containerWidth: number;
    let containerHeight: number;
    let pointerX: number;
    let pointerY: number;
    let closestMood = ref<Mood>(MOODS[0]);

    const { t } = useI18n();

    onMounted(() => {
        containerTop = container.value.getBoundingClientRect().top;
        containerLeft = container.value.getBoundingClientRect().left;
        containerWidth = container.value.getBoundingClientRect().right - containerLeft;
        containerHeight = container.value.getBoundingClientRect().bottom - containerTop;
    })

    window.addEventListener('mouseup', () => {
        isDragging = false;
    });

    function startDrag(e: MouseEvent) {
        isDragging = true;
        containerTop = container.value.getBoundingClientRect().top;
        containerLeft = container.value.getBoundingClientRect().left;
        movePointer(e);
    }

    function drag(e: MouseEvent) {
        if (isDragging) {
            movePointer(e);
        }
    }

    function movePointer(e: MouseEvent) {
        pointerX = (e.clientX - containerLeft);
        pointerY = (e.clientY - containerTop);
        
        if (pointerX >= 0 && pointerX <= container.value.offsetWidth) {
            pointer.value.style.left = pointerX + 'px';
        }
        if (pointerY >= 0 && pointerY <= container.value.offsetHeight) {
            pointer.value.style.top = pointerY + 'px';
        }

        closestMood.value = getClosestMood();
        console.log(closestMood.value);
    }

    function getClosestMood(): Mood {
        let closestMood = MOODS[0];
        let minDist = containerWidth + containerHeight;
        MOODS.forEach((mood) => {
            let distX = Math.abs((mood.position.x * containerWidth) - pointerX);
            let distY = Math.abs((mood.position.y * containerHeight) - pointerY);
            if (distX + distY < minDist) {
                closestMood = mood;
                minDist = distX + distY;
            }
        });
        return closestMood;
    }

    function handleSubmitSearch() {
        if (!pointerX && !pointerY) {
            pointerX = containerWidth / 2;
            pointerY = containerHeight / 2;
        }

        const mood = getClosestMood();
        location.replace('/fr/mood-movie/' + mood?.id)
    }
</script>